﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Dim DSN As SQL ' dsn
#if b4a
	Dim BASE as String = File.DirInternal
#end if
#if b4i
	Dim BASE As String = File.DirLibrary
#end if
#If b4j
	Dim BASE As String = ""
#End If
End Sub
'
' open the db
'
#if b4j
Public Sub Initialize(AppName As String)
	Dim home As String = GetSystemProperty("user.home","")
	If File.IsDirectory(home,"." & AppName) = False Then
		File.MakeDir(home,"." & AppName)
	End If
	Dim JO As JavaObject
    JO.InitializeStatic("java.lang.System")
	BASE = home & JO.RunMethod("getProperty",Array As Object("file.separator")) & "." & AppName
#else
Public Sub Initialize
#end if
	Open
End Sub

'
'
'
private Sub Open
#if b4j
	DSN.InitializeSQLite(BASE,"vars.db",True)
#else
	DSN.Initialize(BASE,"vars.db",True)
#end if
	DSN.ExecNonQuery("create table if not exists vars(name text primary key,val text)") ' create it, if it doesn't exist
End Sub
'
' shut it down
'
public Sub Close
	Try 
		DSN.Close
		'Log(DSN.IsInitialized)
	Catch
		'Log(LastException)
	End Try
End Sub
' 
' this closes and deletes the db file
'
public Sub Clean(Recreate As Boolean)
	Try
		DSN.Close
	Catch
		Log(LastException)
	End Try
	Try
		File.Delete(BASE,"vars.db")
		If Recreate Then
#if b4j
			DSN.InitializeSQLite(BASE,"vars.db",True)
#else
			DSN.Initialize(BASE,"vars.db",True)
#end if
			'Log("RECREATED")
		End If
	Catch
		'Log(LastException)
	End Try
End Sub
'
' Get data with an optional default value
'
Sub GetDef(Name As String, Def As String) As String
	Dim Result As String
#if B4I
	Dim rs As ResultSet = DSN.ExecQuery("select * from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If rs.NextRow  Then
		Result = rs.GetString("val")
	Else
		Put(Name,Def) ' set the default value
		Result = Def
	End If
#end if
#if B4A
	Dim rs As Cursor = DSN.ExecQuery("select * from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If rs.RowCount > 0 Then
		rs.Position = 0
		Result = rs.GetString("val")
	Else
		Put(Name,Def) ' set the default value
		Result = Def
	End If
#end if
#if b4j
	Dim rs As ResultSet = DSN.ExecQuery("select * from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If rs.NextRow  Then
		Result = rs.GetString("val")
	Else
		Put(Name,Def) ' set the default value
		Result = Def
	End If
#end if
	rs.Close
	'Log("Result:" & Result)
	Return Result
End Sub
'
' Get data
'
Sub Get(Name As String) As String
	If Name = "" Then Return ""
	Dim Result As String
#if B4A
	Dim rs As Cursor = DSN.ExecQuery("select * from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If rs.RowCount > 0 Then
		rs.Position = 0
		Result = rs.GetString("val")
	Else
		Result = ""
	End If
#end if
#if B4I
	Dim rs As ResultSet = DSN.ExecQuery("select * from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If rs.NextRow  Then
		Result = rs.GetString("val")
	Else
		Result = ""
	End If
#end if
#if b4j
	Dim rs As ResultSet = DSN.ExecQuery("select * from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If rs.NextRow  Then
		Result = rs.GetString("val")
	Else
		Result = ""
	End If
#end if
	rs.Close
	Return Result
End Sub
'
' set the data
'
Sub Put(Name As String, Val As String)
	DSN.ExecNonQuery("delete from vars where name = '" & Name.Trim.ToLowerCase & "'")
	If Val.trim <> "" Then DSN.ExecNonQuery2("insert into vars(name,val) values(?,?)",Array As Object(Name.Trim.ToLowerCase,Val))
End Sub
